diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/test/packetbb-test-suite.cc ns-3.38/src/network/test/packetbb-test-suite.cc
--- ns-3.37/src/network/test/packetbb-test-suite.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/test/packetbb-test-suite.cc	2023-03-16 20:54:23.808869100 -0700
@@ -267,21 +267,23 @@
 
         packet->TlvPushBack(tlv2);
 
-        uint8_t buffer[] = {0x0c,
-                            0x00,
-                            0x06,
-                            0x00,
-                            0x0a,
-                            0x01,
-                            0x00,
-                            0x02,
-                            0x90,
-                            0x64,
-                            0x04,
-                            0x01,
-                            0x02,
-                            0x03,
-                            0x04};
+        uint8_t buffer[] = {
+            0x0c,
+            0x00,
+            0x06,
+            0x00,
+            0x0a,
+            0x01,
+            0x00,
+            0x02,
+            0x90,
+            0x64,
+            0x04,
+            0x01,
+            0x02,
+            0x03,
+            0x04,
+        };
         AddTestCase(new PbbTestCase("6", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -410,7 +412,8 @@
             0xfc, 0xfd, 0xfe, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a,
             0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18,
             0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26,
-            0x27, 0x28, 0x29, 0x2a, 0x2b, 0x2c};
+            0x27, 0x28, 0x29, 0x2a, 0x2b, 0x2c,
+        };
         tlv2->SetValue(tlv2val, sizeof(tlv2val));
 
         packet->TlvPushBack(tlv2);
@@ -438,7 +441,8 @@
             0xfe, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c,
             0x0d, 0x0e, 0x0f, 0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a,
             0x1b, 0x1c, 0x1d, 0x1e, 0x1f, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28,
-            0x29, 0x2a, 0x2b, 0x2c};
+            0x29, 0x2a, 0x2b, 0x2c,
+        };
         AddTestCase(new PbbTestCase("7", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -474,8 +478,21 @@
         msg1->SetType(1);
         packet->MessagePushBack(msg1);
 
-        uint8_t buffer[] =
-            {0x0c, 0x00, 0x08, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03, 0x00, 0x06, 0x00, 0x00};
+        uint8_t buffer[] = {
+            0x0c,
+            0x00,
+            0x08,
+            0x00,
+            0x02,
+            0x01,
+            0x00,
+            0x01,
+            0x03,
+            0x00,
+            0x06,
+            0x00,
+            0x00,
+        };
         AddTestCase(new PbbTestCase("8", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -524,9 +541,11 @@
         msg2->SetOriginatorAddress(Ipv4Address("10.0.0.1"));
         packet->MessagePushBack(msg2);
 
-        uint8_t buffer[] = {0x0c, 0x00, 0x09, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03,
-                            0x00, 0x06, 0x00, 0x00, 0x02, 0x83, 0x00, /* [14] used to be 0x80 */
-                            0x0a, 0x0a, 0x00, 0x00, 0x01, 0x00, 0x00};
+        uint8_t buffer[] = {
+            0x0c, 0x00, 0x09, 0x00, 0x02, 0x01, 0x00, 0x01,
+            0x03, 0x00, 0x06, 0x00, 0x00, 0x02, 0x83, 0x00, /* [14] used to be 0x80 */
+            0x0a, 0x0a, 0x00, 0x00, 0x01, 0x00, 0x00,
+        };
         AddTestCase(new PbbTestCase("9", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -634,9 +653,11 @@
         msg2->SetHopCount(1);
         packet->MessagePushBack(msg2);
 
-        uint8_t buffer[] = {0x0c, 0x00, 0x0b, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03,
-                            0x00, 0x06, 0x00, 0x00, 0x02, 0xe3, 0x00, /* [14] used to be 0xe0 */
-                            0x0c, 0x0a, 0x00, 0x00, 0x01, 0xff, 0x01, 0x00, 0x00};
+        uint8_t buffer[] = {
+            0x0c, 0x00, 0x0b, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03,
+            0x00, 0x06, 0x00, 0x00, 0x02, 0xe3, 0x00, /* [14] used to be 0xe0 */
+            0x0c, 0x0a, 0x00, 0x00, 0x01, 0xff, 0x01, 0x00, 0x00,
+        };
         AddTestCase(new PbbTestCase("11", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -691,9 +712,11 @@
         msg2->SetSequenceNumber(12345);
         packet->MessagePushBack(msg2);
 
-        uint8_t buffer[] = {0x0c, 0x00, 0x0c, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03, 0x00, 0x06,
-                            0x00, 0x00, 0x02, 0xf3, 0x00, /* [14] - 0xf0 */
-                            0x0e, 0x0a, 0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00};
+        uint8_t buffer[] = {
+            0x0c, 0x00, 0x0c, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03, 0x00, 0x06,
+            0x00, 0x00, 0x02, 0xf3, 0x00, /* [14] - 0xf0 */
+            0x0e, 0x0a, 0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00,
+        };
         AddTestCase(new PbbTestCase("12", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -748,9 +771,11 @@
         msg2->SetSequenceNumber(12345);
         packet->MessagePushBack(msg2);
 
-        uint8_t buffer[] = {0x0c, 0x00, 0x0d, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03, 0x00, 0x06,
-                            0x00, 0x00, 0x02, 0xf3, 0x00, /* [14] - 0xf0 */
-                            0x0e, 0x0a, 0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00};
+        uint8_t buffer[] = {
+            0x0c, 0x00, 0x0d, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03, 0x00, 0x06,
+            0x00, 0x00, 0x02, 0xf3, 0x00, /* [14] - 0xf0 */
+            0x0e, 0x0a, 0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00,
+        };
         AddTestCase(new PbbTestCase("13", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -814,9 +839,11 @@
         msg2->SetSequenceNumber(12345);
         packet->MessagePushBack(msg2);
 
-        uint8_t buffer[] = {0x0c, 0x00, 0x0e, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03, 0x00, 0x08,
-                            0x00, 0x02, 0x01, 0x00, 0x02, 0xf3, 0x00, 0x0e, 0x0a, /* [16] - 0xf0 */
-                            0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00};
+        uint8_t buffer[] = {
+            0x0c, 0x00, 0x0e, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03, 0x00,
+            0x08, 0x00, 0x02, 0x01, 0x00, 0x02, 0xf3, 0x00, 0x0e, 0x0a, /* [16] - 0xf0 */
+            0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00,
+        };
         AddTestCase(new PbbTestCase("14", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -889,10 +916,12 @@
 
         packet->MessagePushBack(msg2);
 
-        uint8_t buffer[] = {0x0c, 0x00, 0x0f, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03, 0x00, 0x08,
-                            0x00, 0x02, 0x01, 0x00, 0x02, 0xf3, 0x00, 0x16, 0x0a, /* [16] - 0xf0 */
-                            0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x01, 0x00,
-                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
+        uint8_t buffer[] = {
+            0x0c, 0x00, 0x0f, 0x00, 0x02, 0x01, 0x00, 0x01, 0x03, 0x00,
+            0x08, 0x00, 0x02, 0x01, 0x00, 0x02, 0xf3, 0x00, 0x16, 0x0a, /* [16] - 0xf0 */
+            0x00, 0x00, 0x01, 0xff, 0x01, 0x30, 0x39, 0x00, 0x00, 0x01,
+            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+        };
         AddTestCase(new PbbTestCase("15", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -2243,7 +2272,8 @@
             0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f,
             0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d,
             0x1e, 0x1f, 0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x28, 0x29, 0x2a, 0x2b,
-            0x2c};
+            0x2c,
+        };
         AddTestCase(new PbbTestCase("28", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
@@ -2307,8 +2337,10 @@
 
         packet->MessagePushBack(m1);
 
-        uint8_t buffer[] = {0x00, 0x01, 0x8f, 0x00, 0x16, 0xab, 0xcd, 0x00, 0x00, 0x00, 0x00, 0x00,
-                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00};
+        uint8_t buffer[] = {
+            0x00, 0x01, 0x8f, 0x00, 0x16, 0xab, 0xcd, 0x00, 0x00, 0x00, 0x00, 0x00,
+            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00,
+        };
         AddTestCase(new PbbTestCase("30", packet, buffer, sizeof(buffer)), TestCase::QUICK);
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/test/packet-test-suite.cc ns-3.38/src/network/test/packet-test-suite.cc
--- ns-3.37/src/network/test/packet-test-suite.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/test/packet-test-suite.cc	2023-03-16 20:54:23.808869100 -0700
@@ -565,7 +565,7 @@
     while (i.HasNext() && j < expected.size())
     {
         ByteTagIterator::Item item = i.Next();
-        struct Expected e = expected[j];
+        Expected e = expected[j];
         std::ostringstream oss;
         oss << "anon::ATestTag<" << e.n << ">";
         NS_TEST_EXPECT_MSG_EQ(item.GetTypeId().GetName(), oss.str(), "trivial");
@@ -603,7 +603,7 @@
     while (i.HasNext() && j < expected.size())
     {
         ByteTagIterator::Item item = i.Next();
-        struct Expected e = expected[j];
+        Expected e = expected[j];
         std::ostringstream oss;
         oss << "anon::ATestTag<" << e.n << ">";
         NS_TEST_EXPECT_MSG_EQ(item.GetTypeId().GetName(), oss.str(), "trivial");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/test/pcap-file-test-suite.cc ns-3.38/src/network/test/pcap-file-test-suite.cc
--- ns-3.37/src/network/test/pcap-file-test-suite.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/test/pcap-file-test-suite.cc	2023-03-16 20:54:23.808869100 -0700
@@ -1116,135 +1116,137 @@
 /**
  * PCAP Packet structure
  */
-typedef struct PACKET_ENTRY
+struct PacketEntry
 {
     uint32_t tsSec;                //!< Time (seconds part)
     uint32_t tsUsec;               //!< Time (micro seconds part)
     uint32_t inclLen;              //!< Length of the entry in the PCAP
     uint32_t origLen;              //!< length of the original packet
     uint16_t data[N_PACKET_BYTES]; //!< Packet data
-} PacketEntry;
+};
 
-static const PacketEntry knownPackets[] = {{2,
-                                            3696,
-                                            46,
-                                            46,
-                                            {0x0001,
-                                             0x0800,
-                                             0x0604,
-                                             0x0001,
-                                             0x0000,
-                                             0x0000,
-                                             0x0003,
-                                             0x0a01,
-                                             0x0201,
-                                             0xffff,
-                                             0xffff,
-                                             0xffff,
-                                             0x0a01,
-                                             0x0204,
-                                             0x0000,
-                                             0x0000}},
-                                           {2,
-                                            3707,
-                                            46,
-                                            46,
-                                            {0x0001,
-                                             0x0800,
-                                             0x0604,
-                                             0x0002,
-                                             0x0000,
-                                             0x0000,
-                                             0x0006,
-                                             0x0a01,
-                                             0x0204,
-                                             0x0000,
-                                             0x0000,
-                                             0x0003,
-                                             0x0a01,
-                                             0x0201,
-                                             0x0000,
-                                             0x0000}},
-                                           {2,
-                                            3801,
-                                            1070,
-                                            1070,
-                                            {0x4500,
-                                             0x041c,
-                                             0x0000,
-                                             0x0000,
-                                             0x3f11,
-                                             0x0000,
-                                             0x0a01,
-                                             0x0101,
-                                             0x0a01,
-                                             0x0204,
-                                             0xc001,
-                                             0x0009,
-                                             0x0408,
-                                             0x0000,
-                                             0x0000,
-                                             0x0000}},
-                                           {2,
-                                            3811,
-                                            46,
-                                            46,
-                                            {0x0001,
-                                             0x0800,
-                                             0x0604,
-                                             0x0001,
-                                             0x0000,
-                                             0x0000,
-                                             0x0006,
-                                             0x0a01,
-                                             0x0204,
-                                             0xffff,
-                                             0xffff,
-                                             0xffff,
-                                             0x0a01,
-                                             0x0201,
-                                             0x0000,
-                                             0x0000}},
-                                           {2,
-                                            3822,
-                                            46,
-                                            46,
-                                            {0x0001,
-                                             0x0800,
-                                             0x0604,
-                                             0x0002,
-                                             0x0000,
-                                             0x0000,
-                                             0x0003,
-                                             0x0a01,
-                                             0x0201,
-                                             0x0000,
-                                             0x0000,
-                                             0x0006,
-                                             0x0a01,
-                                             0x0204,
-                                             0x0000,
-                                             0x0000}},
-                                           {2,
-                                            3915,
-                                            1070,
-                                            1070,
-                                            {0x4500,
-                                             0x041c,
-                                             0x0000,
-                                             0x0000,
-                                             0x4011,
-                                             0x0000,
-                                             0x0a01,
-                                             0x0204,
-                                             0x0a01,
-                                             0x0101,
-                                             0x0009,
-                                             0xc001,
-                                             0x0408,
-                                             0x0000,
-                                             0x0000,
-                                             0x0000}}};
+static const PacketEntry knownPackets[] = {
+    {2,
+     3696,
+     46,
+     46,
+     {0x0001,
+      0x0800,
+      0x0604,
+      0x0001,
+      0x0000,
+      0x0000,
+      0x0003,
+      0x0a01,
+      0x0201,
+      0xffff,
+      0xffff,
+      0xffff,
+      0x0a01,
+      0x0204,
+      0x0000,
+      0x0000}},
+    {2,
+     3707,
+     46,
+     46,
+     {0x0001,
+      0x0800,
+      0x0604,
+      0x0002,
+      0x0000,
+      0x0000,
+      0x0006,
+      0x0a01,
+      0x0204,
+      0x0000,
+      0x0000,
+      0x0003,
+      0x0a01,
+      0x0201,
+      0x0000,
+      0x0000}},
+    {2,
+     3801,
+     1070,
+     1070,
+     {0x4500,
+      0x041c,
+      0x0000,
+      0x0000,
+      0x3f11,
+      0x0000,
+      0x0a01,
+      0x0101,
+      0x0a01,
+      0x0204,
+      0xc001,
+      0x0009,
+      0x0408,
+      0x0000,
+      0x0000,
+      0x0000}},
+    {2,
+     3811,
+     46,
+     46,
+     {0x0001,
+      0x0800,
+      0x0604,
+      0x0001,
+      0x0000,
+      0x0000,
+      0x0006,
+      0x0a01,
+      0x0204,
+      0xffff,
+      0xffff,
+      0xffff,
+      0x0a01,
+      0x0201,
+      0x0000,
+      0x0000}},
+    {2,
+     3822,
+     46,
+     46,
+     {0x0001,
+      0x0800,
+      0x0604,
+      0x0002,
+      0x0000,
+      0x0000,
+      0x0003,
+      0x0a01,
+      0x0201,
+      0x0000,
+      0x0000,
+      0x0006,
+      0x0a01,
+      0x0204,
+      0x0000,
+      0x0000}},
+    {2,
+     3915,
+     1070,
+     1070,
+     {0x4500,
+      0x041c,
+      0x0000,
+      0x0000,
+      0x4011,
+      0x0000,
+      0x0a01,
+      0x0204,
+      0x0a01,
+      0x0101,
+      0x0009,
+      0xc001,
+      0x0408,
+      0x0000,
+      0x0000,
+      0x0000}},
+};
 
 void
 ReadFileTestCase::DoRun()
@@ -1282,10 +1284,10 @@
         NS_TEST_ASSERT_MSG_EQ(f.Fail(), false, "Read() of known good pcap file returns error");
         NS_TEST_ASSERT_MSG_EQ(tsSec,
                               p.tsSec,
-                              "Incorrectly read seconds timestap from known good pcap file");
+                              "Incorrectly read seconds timestamp from known good pcap file");
         NS_TEST_ASSERT_MSG_EQ(tsUsec,
                               p.tsUsec,
-                              "Incorrectly read microseconds timestap from known good pcap file");
+                              "Incorrectly read microseconds timestamp from known good pcap file");
         NS_TEST_ASSERT_MSG_EQ(inclLen,
                               p.inclLen,
                               "Incorrectly read included length from known good packet");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/test/test-data-rate.cc ns-3.38/src/network/test/test-data-rate.cc
--- ns-3.37/src/network/test/test-data-rate.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/test/test-data-rate.cc	2023-03-16 20:54:23.808869100 -0700
@@ -198,7 +198,7 @@
 };
 
 DataRateTestCase2::DataRateTestCase2()
-    : DataRateTestCase("Test arithmatic on DateRate")
+    : DataRateTestCase("Test arithmetic on DateRate")
 {
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/crc32.cc ns-3.38/src/network/utils/crc32.cc
--- ns-3.37/src/network/utils/crc32.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/crc32.cc	2023-03-16 20:54:23.808869100 -0700
@@ -64,7 +64,8 @@
     0xA00AE278, 0xD70DD2EE, 0x4E048354, 0x3903B3C2, 0xA7672661, 0xD06016F7, 0x4969474D, 0x3E6E77DB,
     0xAED16A4A, 0xD9D65ADC, 0x40DF0B66, 0x37D83BF0, 0xA9BCAE53, 0xDEBB9EC5, 0x47B2CF7F, 0x30B5FFE9,
     0xBDBDF21C, 0xCABAC28A, 0x53B39330, 0x24B4A3A6, 0xBAD03605, 0xCDD70693, 0x54DE5729, 0x23D967BF,
-    0xB3667A2E, 0xC4614AB8, 0x5D681B02, 0x2A6F2B94, 0xB40BBE37, 0xC30C8EA1, 0x5A05DF1B, 0x2D02EF8D};
+    0xB3667A2E, 0xC4614AB8, 0x5D681B02, 0x2A6F2B94, 0xB40BBE37, 0xC30C8EA1, 0x5A05DF1B, 0x2D02EF8D,
+};
 
 uint32_t
 CRC32Calculate(const uint8_t* data, int length)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/data-rate.cc ns-3.38/src/network/utils/data-rate.cc
--- ns-3.37/src/network/utils/data-rate.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/data-rate.cc	2023-03-16 20:54:23.808869100 -0700
@@ -198,7 +198,7 @@
 }
 
 DataRate
-DataRate::operator+(DataRate rhs)
+DataRate::operator+(DataRate rhs) const
 {
     return DataRate(m_bps + rhs.m_bps);
 }
@@ -211,7 +211,7 @@
 }
 
 DataRate
-DataRate::operator-(DataRate rhs)
+DataRate::operator-(DataRate rhs) const
 {
     NS_ASSERT_MSG(m_bps >= rhs.m_bps, "Data Rate cannot be negative.");
     return DataRate(m_bps - rhs.m_bps);
@@ -226,7 +226,7 @@
 }
 
 DataRate
-DataRate::operator*(double rhs)
+DataRate::operator*(double rhs) const
 {
     return DataRate(((uint64_t)(m_bps * rhs)));
 }
@@ -239,7 +239,7 @@
 }
 
 DataRate
-DataRate::operator*(uint64_t rhs)
+DataRate::operator*(uint64_t rhs) const
 {
     return DataRate(m_bps * rhs);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/data-rate.h ns-3.38/src/network/utils/data-rate.h
--- ns-3.37/src/network/utils/data-rate.h	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/data-rate.h	2023-03-16 20:54:51.628957000 -0700
@@ -57,7 +57,7 @@
  * * A unit.
  *
  * Whitespace is allowed but not required between the numeric value and
- * multipler or unit.
+ * multiplier or unit.
  *
  * Supported multiplier prefixes:
  *
@@ -124,7 +124,7 @@
      *
      * \param rhs the DataRate to add to this DataRate
      */
-    DataRate operator+(DataRate rhs);
+    DataRate operator+(DataRate rhs) const;
 
     /**
      * \return the DataRate representing the sum of this object with rhs
@@ -138,7 +138,7 @@
      *
      * \param rhs the DataRate to subtract from this DataRate
      */
-    DataRate operator-(DataRate rhs);
+    DataRate operator-(DataRate rhs) const;
 
     /**
      * \return the DataRate representing the difference of this object with rhs
@@ -156,7 +156,7 @@
      *
      * \param rhs the double to multiply to this datarate
      */
-    DataRate operator*(double rhs);
+    DataRate operator*(double rhs) const;
 
     /**
      * \brief Scales the DataRate
@@ -165,7 +165,7 @@
      *
      * \return DataRate object representing the product of this object with rhs
      *
-     * \param rhs the double to multipy to this datarate
+     * \param rhs the double to multiply to this datarate
      */
     DataRate& operator*=(double rhs);
 
@@ -174,16 +174,16 @@
      *
      * \return DataRate object representing the product of this object with rhs
      *
-     * \param rhs the uint64_t to multipy to this datarate
+     * \param rhs the uint64_t to multiply to this datarate
      */
-    DataRate operator*(uint64_t rhs);
+    DataRate operator*(uint64_t rhs) const;
 
     /**
      * \brief Scales the DataRate
      *
      * \return DataRate object representing the product of this object with rhs
      *
-     * \param rhs the uint64_t to multipy to this datarate
+     * \param rhs the uint64_t to multiply to this datarate
      */
     DataRate& operator*=(uint64_t rhs);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/error-model.cc ns-3.38/src/network/utils/error-model.cc
--- ns-3.37/src/network/utils/error-model.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/error-model.cc	2023-03-16 20:54:23.808869100 -0700
@@ -198,7 +198,7 @@
 }
 
 void
-RateErrorModel::SetUnit(enum ErrorUnit error_unit)
+RateErrorModel::SetUnit(ErrorUnit error_unit)
 {
     NS_LOG_FUNCTION(this << error_unit);
     m_unit = error_unit;
@@ -445,7 +445,7 @@
     NS_LOG_FUNCTION(this);
 }
 
-std::list<uint32_t>
+std::list<uint64_t>
 ListErrorModel::GetList() const
 {
     NS_LOG_FUNCTION(this);
@@ -453,7 +453,7 @@
 }
 
 void
-ListErrorModel::SetList(const std::list<uint32_t>& packetlist)
+ListErrorModel::SetList(const std::list<uint64_t>& packetlist)
 {
     NS_LOG_FUNCTION(this << &packetlist);
     m_packetList = packetlist;
@@ -470,7 +470,7 @@
     {
         return false;
     }
-    uint32_t uid = p->GetUid();
+    auto uid = p->GetUid();
     for (PacketListCI i = m_packetList.begin(); i != m_packetList.end(); i++)
     {
         if (uid == *i)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/error-model.h ns-3.38/src/network/utils/error-model.h
--- ns-3.37/src/network/utils/error-model.h	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/error-model.h	2023-03-16 20:54:23.808869100 -0700
@@ -209,7 +209,7 @@
     /**
      * \param error_unit the ErrorUnit to be used by the underlying model
      */
-    void SetUnit(enum ErrorUnit error_unit);
+    void SetUnit(ErrorUnit error_unit);
 
     /**
      * \returns the error rate being applied by the model
@@ -257,8 +257,8 @@
     virtual bool DoCorruptBit(Ptr<Packet> p);
     void DoReset() override;
 
-    enum ErrorUnit m_unit; //!< Error rate unit
-    double m_rate;         //!< Error rate
+    ErrorUnit m_unit; //!< Error rate unit
+    double m_rate;    //!< Error rate
 
     Ptr<RandomVariableStream> m_ranvar; //!< rng stream
 };
@@ -388,22 +388,22 @@
     /**
      * \return a copy of the underlying list
      */
-    std::list<uint32_t> GetList() const;
+    std::list<uint64_t> GetList() const;
     /**
      * \param packetlist The list of packet uids to error.
      *
      * This method overwrites any previously provided list.
      */
-    void SetList(const std::list<uint32_t>& packetlist);
+    void SetList(const std::list<uint64_t>& packetlist);
 
   private:
     bool DoCorrupt(Ptr<Packet> p) override;
     void DoReset() override;
 
     /// Typedef: packet Uid list
-    typedef std::list<uint32_t> PacketList;
+    typedef std::list<uint64_t> PacketList;
     /// Typedef: packet Uid list const iterator
-    typedef std::list<uint32_t>::const_iterator PacketListCI;
+    typedef std::list<uint64_t>::const_iterator PacketListCI;
 
     PacketList m_packetList; //!< container of Uid of packets to corrupt
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/ipv4-address.cc ns-3.38/src/network/utils/ipv4-address.cc
--- ns-3.37/src/network/utils/ipv4-address.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/ipv4-address.cc	2023-03-16 20:54:23.808869100 -0700
@@ -24,63 +24,17 @@
 
 #include <cstdlib>
 
+#ifdef __WIN32__
+#include <WS2tcpip.h>
+#else
+#include <arpa/inet.h>
+#endif
+
 namespace ns3
 {
 
 NS_LOG_COMPONENT_DEFINE("Ipv4Address");
 
-#define ASCII_DOT (0x2e)
-#define ASCII_ZERO (0x30)
-#define ASCII_SLASH (0x2f)
-
-/**
- * \brief Converts a string representing an IP address into the address
- * \param address the address string
- * \returns the address
- */
-static uint32_t
-AsciiToIpv4Host(const char* address)
-{
-    NS_LOG_FUNCTION(&address);
-    uint32_t host = 0;
-    uint8_t numberOfDots = 0;
-    const char* ptr = address;
-
-    NS_ASSERT_MSG(*ptr != ASCII_DOT,
-                  "Error, can not build an IPv4 address from an invalid string: " << address);
-    while (true)
-    {
-        uint8_t byte = 0;
-        while (*ptr != ASCII_DOT && *ptr != 0)
-        {
-            byte *= 10;
-            byte += *ptr - ASCII_ZERO;
-            ptr++;
-        }
-        host <<= 8;
-        host |= byte;
-        if (*ptr == 0)
-        {
-            break;
-        }
-        ptr++;
-        NS_ASSERT_MSG(*ptr != ASCII_DOT,
-                      "Error, can not build an IPv4 address from an invalid string: " << address);
-        numberOfDots++;
-    }
-    NS_ASSERT_MSG(*(ptr - 1) != ASCII_DOT,
-                  "Error, can not build an IPv4 address from an invalid string: " << address);
-    NS_ASSERT_MSG(numberOfDots == 3,
-                  "Error, can not build an IPv4 address from an invalid string: " << address);
-
-    return host;
-}
-
-} // namespace ns3
-
-namespace ns3
-{
-
 Ipv4Mask::Ipv4Mask()
     : m_mask(0x66666666)
 {
@@ -96,7 +50,7 @@
 Ipv4Mask::Ipv4Mask(const char* mask)
 {
     NS_LOG_FUNCTION(this << mask);
-    if (*mask == ASCII_SLASH)
+    if (*mask == '/')
     {
         uint32_t plen = static_cast<uint32_t>(std::atoi(++mask));
         NS_ASSERT(plen <= 32);
@@ -111,7 +65,11 @@
     }
     else
     {
-        m_mask = AsciiToIpv4Host(mask);
+        if (inet_pton(AF_INET, mask, &m_mask) <= 0)
+        {
+            NS_ABORT_MSG("Error, can not build an IPv4 mask from an invalid string: " << mask);
+        }
+        m_mask = ntohl(m_mask);
     }
 }
 
@@ -219,8 +177,16 @@
 Ipv4Address::Ipv4Address(const char* address)
 {
     NS_LOG_FUNCTION(this << address);
-    m_address = AsciiToIpv4Host(address);
+
+    if (inet_pton(AF_INET, address, &m_address) <= 0)
+    {
+        NS_LOG_LOGIC("Error, can not build an IPv4 address from an invalid string: " << address);
+        m_address = 0;
+        m_initialized = false;
+        return;
+    }
     m_initialized = true;
+    m_address = ntohl(m_address);
 }
 
 uint32_t
@@ -242,8 +208,15 @@
 Ipv4Address::Set(const char* address)
 {
     NS_LOG_FUNCTION(this << address);
-    m_address = AsciiToIpv4Host(address);
+    if (inet_pton(AF_INET, address, &m_address) <= 0)
+    {
+        NS_LOG_LOGIC("Error, can not build an IPv4 address from an invalid string: " << address);
+        m_address = 0;
+        m_initialized = false;
+        return;
+    }
     m_initialized = true;
+    m_address = ntohl(m_address);
 }
 
 Ipv4Address
@@ -275,7 +248,7 @@
         // broadcast for this address.
         return false;
     }
-    return ((Get() | mask.GetInverse()) == Get());
+    return ((Get() | mask.Get()) == Ipv4Address::GetBroadcast().Get());
 }
 
 bool
